/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NORMA                                                    */
/* Tabela : NORMA                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 18/02/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_NORMA
BEFORE INSERT OR UPDATE OR DELETE
ON NORMA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNORM:= SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDNORMA,0) <> NVL(:NEW.CDNORMA,0)) OR
         (NVL(:OLD.NMNORMA,0) <> NVL(:NEW.NMNORMA,0)) THEN
         :NEW.DTULTATUNORM:= SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NORMA', '', 'CDNORMA='||:OLD.CDNORMA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NORMA MODIFY DTULTATUNORM DEFAULT SYSDATE
/
