/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUPRIP                                                      */
/* Tabela : PROCINTEPRO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 10/10/2006 - Eduardo H. C. Ramos                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATUPRIP
BEFORE INSERT OR UPDATE OR DELETE
ON PROCINTEPRO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRIP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPROSPECT,0 ) <> NVL(:NEW.CDPROSPECT,0)) OR
         (NVL(:OLD.CDINTEPROS,0) <> NVL(:NEW.CDINTEPROS,0))  OR
         (NVL(:OLD.CDPROCESSO,0) <> NVL(:NEW.CDPROCESSO,0))THEN
         :NEW.DTULTATUPRIP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PROCINTEPRO', '',         'CDPROSPECT='||:OLD.CDPROSPECT||';CDINTEPROS='||:OLD.CDINTEPROS||';CDPROCESSO='||:OLD.CDPROCESSO||';', SYSDATE);                  
   END IF;
END;
/

ALTER TABLE PROCINTEPRO MODIFY DTULTATUPRIP DEFAULT SYSDATE
/